﻿/* 
 *  Author:  Flavio Ribeiro (fr@lps.usp.br)
 *  Date:    January 15, 2011
 *  Version: 0.1
 *
 *  Copyright (c) 2011 Flavio Ribeiro
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a
 *  copy of this software and associated documentation files (the "Software"),
 *  to deal in the Software without restriction, including without limitation
 *  the rights to use, copy, modify, merge, publish, distribute, sublicense,
 *  and/or sell copies of the Software, and to permit persons to whom the
 *  Software is furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 *  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 *  DEALINGS IN THE SOFTWARE.  
 */

package
{
	public class MouseAcceleration
	{
		private var _posX:Number = 0.0;
		private var _posY:Number = 0.0;
		private var _velX:Number = 0.0;
		private var _velY:Number = 0.0;
		private var _accX:Number = 0.0;
		private var _accY:Number = 0.0;

		private var _lastPosX:Number = 0.0;
		private var _lastPosY:Number = 0.0;
		private var _lastVelX:Number = 0.0;
		private var _lastVelY:Number = 0.0;
		private var _lastAccX:Number = 0.0;
		private var _lastAccY:Number = 0.0;
		
		public function MouseAcceleration()
		{
		}
		
		public function update(posX:Number, posY:Number)
		{
			var a:Number = .99;

			_lastPosX = _posX;
			_lastPosY = _posY;
			_lastVelX = a*_lastVelX + (1-a)*_velX;
			_lastVelY = a*_lastVelY + (1-a)*_velY;
			_lastAccX = a*_lastAccX + (1-a)*_accX;
			_lastAccY = a*_lastAccY + (1-a)*_accY;

			_posX = posX;
			_posY = posY;
			_velX = _posX - _lastPosX;
			_velY = _posY - _lastPosY;
			_accX = _velX - _lastVelX;
			_accY = _velY - _lastVelY;
		}
		
		public function getVel():Number
		{
			return Math.sqrt(_lastVelX*_lastVelX + _lastVelY*_lastVelY);
		}
		
		public function getAcc():Number
		{
			return Math.sqrt(_lastAccX*_lastAccX + _lastAccY*_lastAccY);
		}
	}
}
