﻿/* 
 *  Author:  Flavio Ribeiro (fr@lps.usp.br)
 *  Date:    January 15, 2011
 *  Version: 0.1
 *
 *  Copyright (c) 2011 Flavio Ribeiro
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a
 *  copy of this software and associated documentation files (the "Software"),
 *  to deal in the Software without restriction, including without limitation
 *  the rights to use, copy, modify, merge, publish, distribute, sublicense,
 *  and/or sell copies of the Software, and to permit persons to whom the
 *  Software is furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 *  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 *  DEALINGS IN THE SOFTWARE.  
 */

package
{
	import flash.external.*;
	import flash.net.URLVariables;
	
	class QueryString
	{
		private var _url:String;
		private var _query:String;
		private var _parameters:URLVariables = new URLVariables("videoId=debug");
		
		public function QueryString()
		{
			parseQueryString();
		}
	
		public function get url():String
		{
			return _url;
		}
		
		public function get query():String
		{
			return _query;
		}
		
		public function get parameters():Object
		{
			return _parameters;
		}		
	
		private function parseQueryString()
		{
			try 
			{
				_url = ExternalInterface.call("window.location.href.toString");
				_query = ExternalInterface.call("window.location.search.substring", 1);
				if (_url && _query)
					_parameters = new URLVariables(_query);
			}
			catch(e:Error)
			{
//				trace("Caught exception from ExternalInterface (running in standalone player?)."); 
			}
		}
	}
}
